<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: TestOfStatisticsTracker.php 1239 2005-01-17 17:39:11Z andrew $
*/

/**
 * @package    MaxMaintenance
 * @subpackage TestSuite
 * @author     Andrew Hill <andrew@awarez.net>
 */

/**
 * A class for testing the Maintenance_Statistics_Tracker class.
 */
class Maintenance_TestOfStatisticsTracker extends UnitTestCase
{
    
    /**
     * The constructor method.
     */
    function Maintenance_TestOfStatisticsTracker()
    {        
        $this->UnitTestCase();
    }
    
    /**
     * The main test method.
     */
    function testClass()
    {
        debug('Running test', PEAR_LOG_DEBUG);
        $conf =& $GLOBALS['_MAX']['CONF'];
        $tables =& Dal_Table_Core::singleton();
        $dal =& Dal::singleton();
        // Create the required tables
        $tables->createTable('data_raw_tracker_click');
        $tables->createTable('data_raw_tracker_impression');
        $tables->createTable('data_raw_tracker_variable_value');
        $tables->createTable('log_maintenance_statistics');
        $tables->createTable('userlog');
        // Get the data for the tests
        require_once maintenancePath . '/libraries/max/Maintenance/data/TestOfStatisticsTracker.php';
        // Insert the test data
        $dal->execute(TRACKER_FULL_TEST_TRACKER_IMPRESSIONS, $result);
        $dal->execute(TRACKER_FULL_TEST_TRACKER_VARIABLE_VALUES, $result);
        $dal->execute(TRACKER_FULL_TEST_TRACKER_CLICK, $result);
        // Set up the config as desired for testing
        $conf['maintenance']['operation_interval'] = 60;
        $conf['maintenance']['compact_stats'] = false;
        $conf['modules']['Tracker'] = true;
        $conf['table']['split'] = false;
        // Create an appropriate Maintenance_Statistics class
        Maintenance_Statistics::instance('Tracker', $maintenanceStatistics,
                                         new Date('2004-11-26 14:00:00'));
        // Step 1: Summarise raw data into the intermediate tables
        $maintenanceStatistics->summariseIntermediate();
        // Step 2: Summarise intermediate data into summary tables
        $maintenanceStatistics->summariseFinal();
        // Step 3: Delete old raw data that has been summarised
        $maintenanceStatistics->deleteOldData();
        // Step 4: Update the log tables detailing the maintenance statistics run
        $maintenanceStatistics->logCompletion();  
        // Test the results
        $query = "
            SELECT
                COUNT(*) AS number
            FROM
                {$conf['table']['data_raw_tracker_impression']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 1);
        $query = "
            SELECT
                COUNT(*) AS number
            FROM
                {$conf['table']['data_raw_tracker_variable_value']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 1);
        $query = "
            SELECT
                COUNT(*) AS number
            FROM
                {$conf['table']['data_raw_tracker_click']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 30);
        // Drop the tables
        $tables->dropTable($conf['table']['data_raw_tracker_click']);
        $tables->dropTable($conf['table']['data_raw_tracker_impression']);
        $tables->dropTable($conf['table']['data_raw_tracker_variable_value']);
        $tables->dropTable($conf['table']['log_maintenance_statistics']);
        $tables->dropTable($conf['table']['userlog']);
    }
    
}

?>
