<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: TestOfMod_GeoIP.php 1240 2005-01-17 17:40:11Z andrew $
*/

/**
 * @package    MaxDelivery
 * @subpackage TestSuite
 * @author     Andrew Hill <andrew@awarez.net>
 */

require_once MAX_PATH . '/libraries/geotargeting/mod_geoip.inc.php';

/**
 * A class for testing the mod_geoipGetInfo function.
 */
class Delivery_TestOfMod_GeoIP extends UnitTestCase
{
    
    /**
     * The constructor method.
     */
    function Delivery_TestOfMod_GeoIP()
    {        
        $this->UnitTestCase();
    }
    
    /**
     * Test the geoipGetInfo function. In order for this method to
     * be able to run, the mod_geoip module must be corectly installed
     * and configured in Apache.
     */
    function testMod_GeoipGetInfo()
{
        $result = array();
        mod_geoipGetInfo($result);
        $this->assertEqual($result['country_code'], $_SERVER['GEOIP_COUNTRY_CODE']);
        $this->assertEqual($result['country_name'], $_SERVER['GEOIP_COUNTRY_NAME']);
        $this->assertEqual($result['region'], $_SERVER['GEOIP_REGION']);
        $this->assertEqual($result['city'], $_SERVER['GEOIP_CITY']);
        $this->assertEqual($result['postal_code'], $_SERVER['GEOIP_POSTAL_CODE']);
        $this->assertEqual($result['latitude'], $_SERVER['GEOIP_LATITUDE']);
        $this->assertEqual($result['longitude'], $_SERVER['GEOIP_LONGITUDE']);
        $this->assertEqual($result['dma_code'], $_SERVER['GEOIP_DMA_CODE']);
        $this->assertEqual($result['area_code'], $_SERVER['GEOIP_AREA_CODE']);
        $this->assertEqual($result['organisation'], $_SERVER['GEOIP_ORGANIZATION']);
        $this->assertEqual($result['netspeed'], $_SERVER['GEOIP_NETSPEED']);
    }
    
}

?>
